]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
get specname only (like in create_git_repo() above)
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
10d92f71 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
67963237 20# 110 - Functions not yet implemented
cd445739 21
f8e50be5 22# Notes (todo/bugs):
f8e50be5
ER
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
19aa2571 25# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
f8e50be5
ER
26# TODO:
27# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
1ffcdaff
ER
28# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
29# Source10: forwardfix.pl
30# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
6ca6f876
ZU
31# - builder --help:
32# basename: missing operand
33# Try `basename --help' for more information.
34# -- and the normal usage info --
35
9d99a240
ER
36PROGRAM=${0##*/}
37APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
cd112f74 38RCSID='$Id: builder,v 1.645 2011/02/13 17:54:10 glen Exp $' r=${RCSID#* * } rev=${r%% *}
b0f031e7 39VERSION="v0.35/$rev"
d43959a2 40VERSIONSTRING="\
b71f5024 41Build package utility from PLD Linux Packages repository
32131a0e 42$VERSION (C) 1999-2012 Free Penguins".
d43959a2 43
670b1ed4 44CLEAN_PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 45
b7cc0c94
ER
46# required rpm-build-macros
47RPM_MACROS_VER=1.534
48
cd445739 49COMMAND="build"
64ea5308 50TARGET=""
cd445739 51
bde1c404 52SPECFILE=""
d287305c 53BE_VERBOSE=""
4003ad8c 54QUIET=""
cd445739
AM
55CLEAN=""
56DEBUG=""
57NOURLS=""
cd445739
AM
58NOCVSSPEC=""
59NODIST=""
47761337 60NOINIT=""
bc10f694 61PREFMIRRORS=""
cd445739 62UPDATE=""
cd445739
AM
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
cd445739 66
6c1b2e7d
PZ
67# use rpm 4.4.6+ digest format instead of comments if non-zero
68USEDIGEST=
69
e3aa6f5e
ER
70# user agent when fetching files
71USER_AGENT="PLD/Builder($VERSION)"
72
cd445739
AM
73# It can be used i.e. in log file naming.
74# See LOGFILE example.
75DATE=`date +%Y-%m-%d_%H-%M-%S`
76
7534a77d
ER
77# target arch, can also be used for log file naming
78TARGET=$(rpm -E %{_target})
79
cd445739
AM
80# Example: LOGFILE='../log.$PACKAGE_NAME'
81# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
d280fd97 82# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
f5687002 83# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
cd445739
AM
84# Yes, you can use variable name! Note _single_ quotes!
85LOGFILE=''
86
12da9e3d
ER
87# use teeboth Perl wrapper
88# temporary option to disable if broken
89USE_TEEBOTH=yes
90
cd445739
AM
91LOGDIR=""
92LOGDIROK=""
93LOGDIRFAIL=""
94LASTLOG_FILE=""
95
96CHMOD="no"
1da227e8 97CHMOD_MODE="0644"
cd445739 98RPMOPTS=""
d1c5a9a7 99RPMBUILDOPTS=""
cd445739
AM
100BCOND=""
101GROUP_BCONDS="no"
ccffa567
ER
102
103# create symlinks for tools in PACKAGE_DIR, see get_spec()
2dd0af86 104SYMLINK_TOOLS="no"
d287305c 105
106PATCHES=""
107SOURCES=""
cd445739 108ICONS=""
d287305c 109PACKAGE_RELEASE=""
110PACKAGE_VERSION=""
111PACKAGE_NAME=""
14bead22 112ASSUMED_NAME=""
fd71d65c 113PROTOCOL="http"
2060f498
AM
114
115# use lftp by default when available
f4bac425 116USE_LFTP=
2060f498 117lftp --version > /dev/null 2>&1 && USE_LFTP=yes
d4c8d3a9 118PARALLEL_DOWNLOADS=10
2060f498 119
cd445739 120WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 121
939f2c12 122CVS_FORCE=""
f123bcb5 123CVSIGNORE_DF="yes"
cd445739 124CVSTAG=""
7446994b
KK
125GIT_SERVER="git://git.pld-linux.org"
126GIT_PUSH="git@git.pld-linux.org"
76636346 127PACKAGES_DIR="packages"
a8f917c2 128HEAD_DETACHED=""
3189511a 129DEPTH=""
3f79cb18 130ALL_BRANCHES=""
608c01a7 131REMOTE_PLD="origin"
406b9ecf 132NEW_REPO=""
939f2c12 133
cd445739
AM
134RES_FILE=""
135
cd445739 136DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 137ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 138
36d03934 139DEF_NICE_LEVEL=19
86aafdbe 140SCHEDTOOL="auto"
cd445739
AM
141
142FAIL_IF_NO_SOURCES="yes"
143
18e5347d
ER
144# let get_files skip over files which are present to get those damn files fetched
145SKIP_EXISTING_FILES="no"
146
975d7b23 147TRY_UPGRADE=""
257af81b
ER
148# should the specfile be restored if upgrade failed?
149REVERT_BROKEN_UPGRADE="yes"
150
90baf90b
ER
151if rpm --specsrpm 2>/dev/null; then
152 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 153 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
154else
155 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
156 if [ -x /usr/bin/rpm-getdeps ]; then
157 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
158 else
159 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
160 fi
ab4a2b6e
ER
161fi
162
8a390970 163UPDATE_POLDEK_INDEXES_OPTS=""
90baf90b 164
cd445739
AM
165# Here we load saved user environment used to
166# predefine options set above, or passed to builder
167# in command line.
168# This one reads global system environment settings:
169if [ -f ~/etc/builderrc ]; then
170 . ~/etc/builderrc
171fi
172# And this one cascades settings using user personal
173# builder settings.
174# Example of ~/.builderrc:
175#
176#UPDATE_POLDEK_INDEXES="yes"
8a390970 177#UPDATE_POLDEK_INDEXES_OPTS="--mo=nodiff"
cd445739
AM
178#FETCH_BUILD_REQUIRES="yes"
179#REMOVE_BUILD_REQUIRES="force"
180#GROUP_BCONDS="yes"
181#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 182#TITLECHANGE=no
cd445739 183#
a83e5405 184SU_SUDO=""
cd445739
AM
185if [ -n "$HOME_ETC" ]; then
186 USER_CFG="$HOME_ETC/.builderrc"
20117088 187 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
188else
189 USER_CFG=~/.builderrc
20117088 190 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
191fi
192
193[ -f "$USER_CFG" ] && . "$USER_CFG"
194
86aafdbe
ER
195if [ "$SCHEDTOOL" = "auto" ]; then
196 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
197 SCHEDTOOL="schedtool -B -e"
198 else
199 SCHEDTOOL="no"
200 fi
201fi
202
ca2e6c31 203if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
204 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
205 GETURI2="$GETURI"
206 OUTFILEOPT="-O"
ca2e6c31 207elif [ -n "$USE_AXEL" ]; then
cede92b3 208 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
209 GETURI2="$GETURI"
210 OUTFILEOPT="-o"
9639be96 211elif [ -n "$USE_LFTP" ]; then
9639be96
AM
212 GETURI=download_lftp
213 GETURI2=$GETURI
214 OUTFILEOPT=""
ca2e6c31 215else
5700ee32
ER
216 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
217 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
218 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 219 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 220
7e365483
KK
221 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
222 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
223 OUTFILEOPT="-O"
2bc5451f 224fi
11468b23 225
11468b23
AM
226GETLOCAL="cp -a"
227
15e34b63 228if rpm --version 2>&1 | grep -q '4.0.[0-2]'; then
11468b23
AM
229 RPM="rpm"
230 RPMBUILD="rpm"
231else
232 RPM="rpm"
233 RPMBUILD="rpmbuild"
234fi
235
c86939e2 236#
237# sanity checks
238#
239if [ -d $HOME/rpm/SOURCES ]; then
240 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
241 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
242 exit 1
243fi
244
a8c9a155 245POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 246POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 247
12da9e3d 248# TODO: add teeboth
f6711e2a 249run_poldek() {
390d081d 250 RES_FILE=$(tempfile)
cd445739
AM
251 if [ -n "$LOGFILE" ]; then
252 LOG=`eval echo $LOGFILE`
253 if [ -n "$LASTLOG_FILE" ]; then
254 echo "LASTLOG=$LOG" > $LASTLOG_FILE
255 fi
86aafdbe 256 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
12da9e3d 257 # FIXME $exit_pldk undefined
cd445739
AM
258 return $exit_pldk
259 else
86aafdbe 260 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
261 return `cat ${RES_FILE}`
262 rm -rf ${RES_FILE}
263 fi
264}
265
cd445739
AM
266#---------------------------------------------
267# functions
da946cd6 268
f4bac425 269download_lftp() {
6928bb29 270 local outfile=$1 url=$2 retval tmpfile
f4bac425
ER
271 # TODO: use mktemp
272 tmpfile=$outfile.tmp
4d1fc6ce
AM
273 lftp -c "
274 $([ "$DEBUG" = "yes" ] && echo "debug 5;")
78ff632e 275 set ssl:verify-certificate no;
4d1fc6ce
AM
276 set net:max-retries $WGET_RETRIES;
277 set http:user-agent \"$USER_AGENT\";
d4c8d3a9 278 pget -n $PARALLEL_DOWNLOADS -c \"$url\" -o \"$tmpfile\"
4d1fc6ce 279 "
f4bac425
ER
280
281 retval=$?
282 if [ $retval -eq 0 ]; then
283 mv -f "$tmpfile" "$outfile"
284 else
285 rm -f "$tmpfile"
286 fi
287 return $retval
288}
289
f6711e2a 290usage() {
cd445739 291 if [ -n "$DEBUG" ]; then set -xv; fi
647fead0
ER
292# NOTE:
293# to make this output parseable by bash-completion _parse_help()
294# if the line contains short and long option, it will take only the long option
295# but if you want both being completed, put the short option to separate line
cd445739 296 echo "\
3f79cb18 297Usage: builder [--all-branches] [-D|--debug] [-V|--version] [--short-version] [-a|--add_cvs] [-b|-ba|--build]
6594293d 298[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
0c8e5e9d 299[{-cf|--cvs-force}] [{-B|--branch} <branch>] [--depth <number>]
fd71d65c 300[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
ccb03bc0 301[-q|--quiet] [--date <yyyy-mm-dd> [-r <tag>] [{-T|--tag <tag>]
a7b2951c 302[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
b3b584c5 303[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 304[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 305[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
ccb03bc0 306<package>[.spec][:tag]
2a5f078d 307
647fead0
ER
308-4 - force IPv4 when transferring files
309-6 - force IPv6 when transferring files
310-5,
311--update-md5 - update md5 comments in spec, implies -nd -ncs
312-a5,
313--add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
4ca1edbd 314--all-branches - make shallow fetch of all branches; --depth required
cd445739 315-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
316-D, --debug - enable builder script debugging mode,
317-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
318-V, --version - output builder version string
319--short-version - output builder short version
647fead0
ER
320-a - try add new package to PLD repo.
321-b,
322-ba
323 - get all files from PLD repo or HTTP/FTP and build package
cd445739 324 from <package>.spec,
647fead0 325-bb - get all files from PLD repo or HTTP/FTP and build binary
cd445739 326 only package from <package>.spec,
647fead0 327-bp - execute the %prep phase of <package>.spec,
6594293d
AG
328-bc - execute the %build phase of <package>.spec,
329-bi - execute the %install phase of <package>.spec
4ca1edbd 330-bl - execute the %files phase of <package>.spec
647fead0 331-bs - get all files from PLD repo or HTTP/FTP and only pack
cd445739 332 them into src.rpm,
6594293d 333--short-circuit - short-circuit build
cd445739 334-B, --branch - add branch
647fead0
ER
335-c,
336--clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
387eaf99 337 may be used with building process.
6f10b394 338-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
4ca1edbd
KK
339 SPECS and \$RPM_BUILD_ROOT). Doesn't run any rpm building.
340-cf, --cvs-force - use -f when tagging
eccfb714 341--define '<macro> <value>'
cd445739 342 - define a macro <macro> with value <value>,
4ca1edbd 343--depth <number> - make shallow fetch
44058243
ER
344--alt_kernel <kernel>
345 - same as --define 'alt_kernel <kernel>'
cd445739 346--nodeps - rpm won't check any dependences
647fead0
ER
347-g
348--get - get <package>.spec and all related files from PLD repo
cd445739 349-h, --help - this message,
647fead0
ER
350-j N - set %_smp_mflags to propagate concurrent jobs
351--ftp - use FTP protocol to access distfiles server
352--http - use HTTP protocol to access distfiles server
353-l <logfile>, --logtofile=<logfile>
cd445739 354 - log all to file,
cd445739 355-ncs, --no-cvs-specs
ccb03bc0 356 - don't pull from PLD repo
cd445739
AM
357-nd, --no-distfiles - don't download from distfiles
358-nm, --no-mirrors - don't download from mirror, if source URL is given,
359-nu, --no-urls - don't try to download from FTP/HTTP location,
7cbc2d88 360-ns, --no-srcs - don't download Sources/Patches
cd445739
AM
361-ns0, --no-source0 - don't download Source0
362-nn, --no-net - don't download anything from the net
647fead0 363-p N - set PARALLEL_DOWNLOADS to N (default $PARALLEL_DOWNLOADS)
4ca1edbd
KK
364-pm, --prefer-mirrors
365 - prefer mirrors (if any) over distfiles for SOURCES
b572253e 366--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d 367-ske,
4ca1edbd
KK
368--skip-existing-files
369 - skip existing files in get_files
cd445739
AM
370--opts <rpm opts> - additional options for rpm
371-q, --quiet - be quiet,
ccb03bc0
KK
372--date yyyy-mm-dd - build package using resources from specified date,
373-r <tag>, --cvstag <ref>
374 - build package using resources from specified branch/tag,
5053a974 375-A - build package using master branch as any sticky tags/branch/date being reset.
cd445739
AM
376-R, --fetch-build-requires
377 - fetch what is BuildRequired,
378-RB, --remove-build-requires
379 - remove all you fetched with -R or --fetch-build-requires
380 remember, this option requires confirmation,
381-FRB, --force-remove-build-requires
382 - remove all you fetched with -R or --fetch-build-requires
383 remember, this option works without confirmation,
4ca1edbd
KK
384-sd, --source-distfiles
385 - list sources available from distfiles (intended for offline
06541433
JR
386 operations; does not work when Icon field is present
387 but icon file is absent),
4ca1edbd
KK
388-sc, --source-cvs - list sources available from PLD repo
389-sdp, --source-distfiles-paths
390 - list sources available from distfiles -
06541433
JR
391 paths relative to distfiles directory (intended for offline
392 operations; does not work when Icon field is present
393 but icon file is absent),
a7eefc54 394-sf, --source-files - list sources - bare filenames (intended for offline
395 operations; does not work when Icon field is present
3621e588 396 but icon file is absent),
4ca1edbd
KK
397-lsp, --source-paths
398 - list sources - filenames with full local paths (intended for
a7eefc54 399 offline operations; does not work when Icon field is present
3621e588 400 but icon file is absent),
2dddf439
ER
401-su, --source-urls - list urls - urls to sources and patches
402 intended for copying urls with spec with lots of macros in urls
ccb03bc0
KK
403-T <tag> , --tag <tag>
404 - add git tag <tag> for files,
cd445739 405-Tvs, --tag-version-stable
ccb03bc0 406 - add git tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 407-Ts, --tag-stable
ccb03bc0 408 - add git tag STABLE for files,
647fead0
ER
409-Tv,
410--tag-version - add git tag NAME-VERSION-RELEASE for files,
cd445739
AM
411-Tp, --tag-prefix <prefix>
412 - add <prefix> to NAME-VERSION-RELEASE tags,
413-tt, --test-tag <prefix>
414 - fail if tag is already present,
50321881
JK
415-ir, --integer-release-only
416 - allow only integer and snapshot releases
cd445739
AM
417-v, --verbose - be verbose,
418-u, --try-upgrade - check version, and try to upgrade package
419-un, --try-upgrade-with-float-version
420 - as above, but allow float version
4ca1edbd 421 php-pear-Services_Digg/
0907f1eb 422--upgrade-version - upgrade to specified version in try-upgrade
deccc50e 423-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
424-Upi, --update-poldek-indexes
425 - refresh or make poldek package index files.
647fead0
ER
426-sp <patchnumber>,
427--skip-patch <patchnumber>
8bd5e66d 428 - don't apply <patchnumber>. may be repeated.
647fead0
ER
429-np <patchnumber>,
430--nopatch <patchnumber>
8bd5e66d 431 - abort instead of applying patch <patchnumber>
fc8edbe5
ER
432--noinit
433 - do not initialize SPECS_DIR and SOURCES_DIR (set them to .)
dfe2cb9a
MK
434--show-bconds - show available conditional builds, which can be used
435 - with --with and/or --without switches.
b05205af
BZ
436--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by ./repackage.sh script.
437 In other words, the output is parseable by scripts.
24a97174 438--show-avail-bconds - show available bconds
647fead0
ER
439--with <feature>,
440--without <feature>
cd445739
AM
441 - conditional build package depending on %_with_<feature>/
442 %_without_<feature> macro switch. You may now use
443 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
444 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 445--target <platform>, --target=<platform>
a6494cd4
ER
446 - build for platform <platform>.
447--init-rpm-dir - initialize ~/rpm directory structure
5a491465 448"
449}
450
390d081d
ER
451# create tempfile. as secure as possible
452tempfile() {
ff5e57ba 453 mktemp --tmpdir -t builder.$PACKAGE_NAME.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
390d081d
ER
454}
455
397fa865 456tempdir() {
ff5e57ba 457 mktemp --tmpdir -d builder.$PACKAGE_NAME.XXXXXX
397fa865
KK
458}
459
8cc8f5c0
ER
460# inserts git log instead of %changelog
461# outputs name of modified file created by tempfile
462insert_gitlog() {
397fa865 463 local SPECFILE=$1 specdir=$(tempdir) gitlog=$(tempfile) speclog=$(tempfile)
8cc8f5c0
ER
464
465 # allow this being customized
466 local log_entries=$(rpm -E '%{?_buildchangelogtruncate}')
467
468 # rpm5.org/rpm.org do not parse any other date format than 'Wed Jan 1 1997'
469 # otherwise i'd use --date=iso here
470 # http://rpm5.org/cvs/fileview?f=rpm/build/parseChangelog.c&v=2.44.2.1
471 # http://rpm.org/gitweb?p=rpm.git;a=blob;f=build/parseChangelog.c#l31
472 # NOTE: changelog date is always in UTC for rpmbuild
473 # * 1265749244 +0000 Random Hacker <nikt@pld-linux.org> 9370900
9fd1eb80 474 git rev-list --date-order -${log_entries:-20} HEAD 2>/dev/null | while read sha1; do
f8704064 475 local logfmt='%B%n'
fafbe559 476 git notes list $sha1 > /dev/null 2>&1 && logfmt=%N
f8704064 477 git log -n 1 $sha1 --format=format:"* %ad %an <%ae> %h%n${logfmt}%n" --date=raw | sed '/^$/q'
9c0fe78c 478 done > $gitlog
9e269b3c
ER
479
480 # add link to full git logs
481 local giturl="http://git.pld-linux.org/?p=packages/$PACKAGE_NAME.git;a=log"
482 if [ -n "$CVSTAG" ]; then
483 giturl="$giturl;h=$CVSTAG"
484 fi
485 local gitauthor="PLD Linux Team <feedback@pld-linux.org>"
486 LC_ALL=C gawk -vgiturl="$giturl" -vgitauthor="$gitauthor" -vpackage=$PACKAGE_NAME 'BEGIN{
487 printf("* %s %s\n- For complete changelog see: %s\n", strftime("%a %b %d %Y"), gitauthor, giturl);
488 print;
489 exit
490 }' > $speclog
491
492 LC_ALL=C gawk '/^\* /{printf("* %s %s\n", strftime("%a %b %d %Y", $2), substr($0, length($1)+length($2)+length($3)+4)); next}{print}' $gitlog >> $speclog
8cc8f5c0
ER
493 sed '/^%changelog/,$d' $SPECFILE | sed -e "\${
494 a%changelog
495 r $speclog
496 }
397fa865 497 " > $specdir/$SPECFILE
8cc8f5c0 498 rm -f $gitlog $speclog
397fa865 499 echo $specdir
8cc8f5c0
ER
500}
501
12da9e3d
ER
502# @param string logfile
503# @param varargs... commands to execute
504teeboth() {
505 local rc
506 # use teeboth from toys/cleanbuild, if available and enabled
507 if [ "$USE_TEEBOTH" = "yes" ] && [ -x $APPDIR/teeboth ]; then
508 $APPDIR/teeboth "$@"
509 rc=$?
510 else
511 local efile rc logfile=$1; shift
512 if [ "$logfile" ]; then
513 efile=$(tempfile)
806a7b72 514 { "$@" 2>&1; echo $? > $efile; } | tee -a $logfile
12da9e3d
ER
515 rc=$(< $efile)
516 rm -f $efile
517 else
551a62ae 518 "$@"
12da9e3d
ER
519 rc=$?
520 fi
521 fi
522 return $rc
523}
524
31d2bd0b
ER
525# change dependency to specname
526# common changes:
527# - perl(Package::Name) -> perl-Package-Name
528depspecname() {
529 local package="$1"
530
560c4b1a 531 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
31d2bd0b
ER
532 echo "$package"
533}
534
c890b916 535update_shell_title() {
a0d6396b 536 [ -t 1 ] || return
0b65d15e 537 local len=${COLUMNS:-80}
5c795f16 538 local msg="$(echo "$*" | cut -c-$len)"
0b65d15e 539
e225de91
ER
540 if [ -n "$BE_VERBOSE" ]; then
541 echo >&2 "$(date +%s.%N) $*"
542 fi
543
5c795f16 544 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
138bbc98
ER
545 local pkg
546 if [ -n "$PACKAGE_NAME" ]; then
547 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
548 else
549 pkg=${SPECFILE}
550 fi
551
552 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 553 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
554 case "$TERM" in
555 cygwin|xterm*)
556 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
557 ;;
558 screen*)
559 echo >&2 -ne "\033]0;$msg\007"
560 ;;
561 esac
562 fi
c890b916
ER
563}
564
7e40520f
ER
565# set TARGET from BuildArch: from SPECFILE
566set_spec_target() {
ce40491a 567 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
8c91ee46 568 local tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
ce40491a 569 if [ "$tmp" ]; then
8c91ee46 570 local target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
571 TARGET="$tmp"
572 case "$RPMBUILD" in
573 "rpmbuild")
f9109a96 574 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 575 "rpm")
ce40491a 576 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 577 esac
ce40491a
ER
578 fi
579 fi
7e40520f
ER
580}
581
ace3fd80
ER
582# runs rpm with minimal macroset
583minirpm() {
fa4bf1df 584 # we reset macros not to contain macros.build as all the %() macros are
559d511f 585 # executed here, while none of them are actually needed.
559d511f 586 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 587 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
588
589 # TODO: move these to /usr/lib/rpm/macros
20117088 590 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 591%x8664 x86_64 amd64 ia32e
f78a0bb7 592%alt_kernel %{nil}
593%_alt_kernel %{nil}
5ff15c97 594%bootstrap_release() %{1}
407b204b
ER
595%requires_releq_kernel_up(s:n:) %{nil}
596%requires_releq_kernel_smp(s:n:) %{nil}
597%requires_releq_kernel(s:n:) %{nil}
6b8134e3 598%requires_releq() %{nil}
bb01dee9 599%pyrequires_eq() %{nil}
559d511f 600%requires_eq() %{nil}
c13be3d1 601%requires_eq_to() %{nil}
99c05e13 602%requires_ge() %{nil}
500b0eb8
ER
603%requires_ge_to() %{nil}
604%requires_ge() %{nil}
407b204b
ER
605%releq_kernel_up(n:) ERROR
606%releq_kernel_smp(n:) ERROR
607%releq_kernel(n:) ERROR
74d9fd14 608%kgcc_package ERROR
237bd3f1 609%_fontsdir ERROR
7141278d 610%ruby_version ERROR
611%ruby_ver_requires_eq() %{nil}
612%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 613%__php_api_requires() %{nil}
7141278d 614%php_major_version ERROR
615%php_api_version ERROR
99f819cf
AM
616%requires_xorg_xserver_extension %{nil}
617%requires_xorg_xserver_xinput %{nil}
618%requires_xorg_xserver_font %{nil}
619%requires_xorg_xserver_videodrv %{nil}
7141278d 620%py_ver ERROR
41035426
ER
621%perl_vendorarch ERROR
622%perl_vendorlib ERROR
703ae20b
ER
623# damn. need it here! - copied from /usr/lib/rpm/macros.build
624%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
625%patchset_source(f:b:) %(
626 base=%{-b*}%{!-b*:10000};
627 start=$(expr $base + %1);
628 end=$(expr $base + %{?2}%{!?2:%{1}});
629 # we need to call seq twice as it doesn't allow two formats
630 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
631 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
632 paste %{tmpdir}/__ps{1,2};
633 rm -f %{tmpdir}/__ps{1,2};
634) \
635%{nil}
991f09a5
ER
636%add_etc_shells(p) %{p:<lua>}
637%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
638%lua_add_etc_shells() %{nil}
639%lua_remove_etc_shells() %{nil}
0ca65fa4
JK
640%required_jdk %{nil}
641%buildrequires_jdk %{nil}
f9063abe 642%pear_package_print_optionalpackages %{nil}
fb198857 643EOF
3d12d055 644 if [ "$NOINIT" = "yes" ] ; then
20117088 645 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
646%_specdir ./
647%_sourcedir ./
648EOF
c039643c 649 fi
670b1ed4 650 eval PATH=$CLEAN_PATH $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
651}
652
653cache_rpm_dump() {
654 if [ -n "$DEBUG" ]; then
655 set -x
656 set -v
657 fi
658
d1d24c14 659 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 660 update_shell_title "cache_rpm_dump using rpm-specdump command"
646d81cf 661 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND --define "_specdir $PACKAGE_DIR" --define "_sourcedir $PACKAGE_DIR" $PACKAGE_DIR/$SPECFILE)
d1d24c14 662 else
525bf240 663 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
664 local rpm_dump
665 rpm_dump=`
666 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
667 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
668 case "$RPMBUILD" in
669 rpm)
670 ARGS='-bp'
671 ;;
672 rpmbuild)
673 ARGS='--nodigest --nosignature --nobuild'
674 ;;
675 esac
676 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
677 `
678 if [ $? -gt 0 ]; then
679 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
680 echo "$error" >&2
681 Exit_error err_build_fail
682 fi
d05e8080 683
d1d24c14
ER
684 # make small dump cache
685 rpm_dump_cache=`echo "$rpm_dump" | awk '
686 $2 ~ /^SOURCEURL/ {print}
687 $2 ~ /^PATCHURL/ {print}
688 $2 ~ /^nosource/ {print}
689 $2 ~ /^PACKAGE_/ {print}
690 '`
691 fi
d05e8080 692
13974367 693 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
694}
695
ace3fd80 696rpm_dump() {
cd445739 697 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 698 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
699 fi
700 echo "$rpm_dump_cache"
701}
702
f6711e2a 703get_icons() {
d05e8080 704 update_shell_title "get icons"
9d99a240 705 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
d05e8080
ER
706 if [ -z "$ICONS" ]; then
707 return
708 fi
709
975d7b23 710 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
711}
712
f6711e2a 713parse_spec() {
af4d5315 714 update_shell_title "parsing specfile"
cd445739 715 if [ -n "$DEBUG" ]; then
518ff1fb
ER
716 set -x
717 set -v
cd445739 718 fi
b2975fc3 719
d05e8080 720 # icons are needed for successful spec parse
518ff1fb 721 get_icons
d05e8080 722
9c909460 723 cd $PACKAGE_DIR
cd445739 724 cache_rpm_dump
00fcec7e 725
15e34b63 726 if rpm_dump | grep -qEi ":.*nosource.*1"; then
cd445739
AM
727 FAIL_IF_NO_SOURCES="no"
728 fi
729
7cbc2d88
ER
730 if [ "$NOSRCS" != "yes" ]; then
731 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
732 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
733 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
734 fi
735
dfe2b2d9
ER
736 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
737 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
738 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 739
0b4119a2 740 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 741 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
742 fi
743
cd445739
AM
744 if [ -n "$BE_VERBOSE" ]; then
745 echo "- Sources : `nourl $SOURCES`"
746 if [ -n "$PATCHES" ]; then
747 echo "- Patches : `nourl $PATCHES`"
748 else
749 echo "- Patches : *no patches needed*"
750 fi
751 if [ -n "$ICONS" ]; then
752 echo "- Icon : `nourl $ICONS`"
753 else
754 echo "- Icon : *no package icon*"
755 fi
756 echo "- Name : $PACKAGE_NAME"
757 echo "- Version : $PACKAGE_VERSION"
758 echo "- Release : $PACKAGE_RELEASE"
759 fi
13974367
ER
760
761 update_shell_title "parse_spec: OK!"
cd445739
AM
762}
763
f6711e2a 764Exit_error() {
cd445739 765 if [ -n "$DEBUG" ]; then
518ff1fb
ER
766 set -x
767 set -v
cd445739
AM
768 fi
769
770 cd "$__PWD"
771
772 case "$1" in
773 "err_no_spec_in_cmdl" )
774 remove_build_requires
45e2a818 775 echo >&2 "ERROR: spec file name not specified."
cd445739 776 exit 2 ;;
a08d92fc 777 "err_invalid_cmdline" )
45e2a818 778 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 779 exit 2 ;;
cd445739
AM
780 "err_no_spec_in_repo" )
781 remove_build_requires
bba21388 782 echo >&2 "Error: spec file not stored in PLD repo."
cd445739
AM
783 exit 3 ;;
784 "err_no_source_in_repo" )
785 remove_build_requires
bba21388 786 echo >&2 "Error: some source, patch or icon files not stored in PLD repo. ($2)"
cd445739 787 exit 4 ;;
703b6deb 788 "err_cvs_add_failed" )
bba21388 789 echo >&2 "Error: failed to add package to PLD repo."
703b6deb 790 exit 4 ;;
cd445739
AM
791 "err_build_fail" )
792 remove_build_requires
45e2a818 793 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 794 exit 5 ;;
78eab2a1
AM
795 "err_no_package_data" )
796 remove_build_requires
45e2a818 797 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 798 exit 6 ;;
ce40491a 799 "err_tag_exists" )
50321881 800 remove_build_requires
d2842af2 801 echo >&2 "Tag ${2} already exists"
50321881 802 exit 9 ;;
ce40491a 803 "err_fract_rel" )
50321881 804 remove_build_requires
45e2a818 805 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 806 exit 10 ;;
fb96e0b5
AM
807 "err_branch_exists" )
808 remove_build_requires
45e2a818 809 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 810 exit 11 ;;
cfc497c0
ER
811 "err_acl_deny" )
812 remove_build_requires
45e2a818 813 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 814 exit 12 ;;
406b9ecf
KK
815 "err_remote_problem" )
816 remove_build_requires
817 echo >&2 "Error: problem with remote (${2})"
818 exit 13 ;;
6217f407
KK
819 "err_no_checkut" )
820 echo >&2 "Error: cannot checkout $2"
821 exit 14 ;;
67963237 822 "err_not_implemented" )
779fcca4 823 remove_build_requires
67963237
KK
824 echo >&2 "Error: functionality not yet imlemented"
825 exit 110 ;;
cd445739 826 esac
45e2a818 827 echo >&2 "Unknown error."
73848362 828 exit 100
cd445739
AM
829}
830
f6711e2a 831init_builder() {
cd445739 832 if [ -n "$DEBUG" ]; then
518ff1fb
ER
833 set -x
834 set -v
0dd6320d 835 fi
cd445739 836
4aeb9973 837 if [ "$NOINIT" != "yes" ] ; then
9c909460 838 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
b7cc0c94 839
09bf17c9 840 local macros_ver=$(rpm -E %?rpm_build_macros)
b7cc0c94
ER
841 if [ -z "$macros_ver" ]; then
842 REPO_DIR=$TOP_DIR/packages
843 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
844 else
845 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
846 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
847 exit 1
848 fi
849 REPO_DIR=$TOP_DIR
850 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
851 fi
29e90b02 852 else
9c909460
AM
853 REPO_DIR="."
854 PACKAGE_DIR="."
29e90b02 855 fi
52f3ced3
KK
856 export GIT_WORK_TREE=$PACKAGE_DIR
857 export GIT_DIR=$PACKAGE_DIR/.git
cd445739 858
acd0d41d 859 if [ -d "$GIT_DIR" ] && [ -z "$CVSTAG" ] && git rev-parse --verify -q HEAD > /dev/null; then
a095de80
KK
860 if CVSTAG=$(GIT_DIR=$GIT_DIR git symbolic-ref HEAD) 2>/dev/null; then
861 CVSTAG=${CVSTAG#refs/heads/}
862 if [ "$CVSTAG" != "master" ]; then
863 echo >&2 "builder: Active branch $CVSTAG. Use -r BRANCHNAME to override"
864 fi
865 else
866 echo >&2 "On detached HEAD. Use -r BRANCHNAME to override"
867 HEAD_DETACHED="yes"
868 fi
869 elif [ "$CVSTAG" = "HEAD" ]; then
870 # assume -r HEAD is same as -A
871 CVSTAG="master"
872 fi
873
a8c9a155 874 __PWD=$(pwd)
00fcec7e 875}
876
406b9ecf
KK
877create_git_repo() {
878 update_shell_title "add_package"
879
880 if [ -n "$DEBUG" ]; then
881 set -x
882 set -v
883 fi
884
885 cd "$REPO_DIR"
886 SPECFILE=$(basename $SPECFILE)
887 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
888 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
889 exit 101
890 fi
891 [ -d "$ASSUMED_NAME/.git" ] || NEW_REPO=yes
c6418b06 892 ssh $GIT_PUSH create ${ASSUMED_NAME} || Exit_error err_cvs_add_failed
406b9ecf 893 git init
eda17ab7
KK
894 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git && \
895 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME} \
896 || Exit_error err_remote_problem $REMOTE_PLD
406b9ecf
KK
897}
898
f6711e2a 899get_spec() {
c890b916 900
2e5be021 901 update_shell_title "get_spec"
c890b916 902
cd445739 903 if [ -n "$DEBUG" ]; then
518ff1fb
ER
904 set -x
905 set -v
cd445739
AM
906 fi
907
9c909460 908 cd "$REPO_DIR"
e0ddd96d 909 SPECFILE=$(basename $SPECFILE)
1ef6f5de 910 if [ "$NOCVSSPEC" != "yes" ]; then
3189511a 911 if [ -z "$DEPTH" ]; then
30419e36 912 if [ -d "$PACKAGE_DIR/.git" ]; then
608c01a7 913 git fetch $REMOTE_PLD || Exit_error err_no_spec_in_repo
3189511a 914 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
30419e36
ER
915 if [ ! -r "$PACKAGE_DIR/$SPECFILE" ]; then
916 echo "ERROR: No package to add ($PACKAGE_DIR/$SPECFILE)" >&2
3189511a
KK
917 exit 101
918 fi
919 Exit_error err_not_implemented
920 else
921 (
922 unset GIT_WORK_TREE
eda17ab7 923 git clone -o $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git || {
588cb3a9 924 # softfail if new package, i.e not yet added to PLD rep
30419e36 925 [ ! -f "$PACKAGE_DIR/$SPECFILE" ] && Exit_error err_no_spec_in_repo
3189511a
KK
926 echo "Warning: package not in CVS - assuming new package"
927 NOCVSSPEC="yes"
928 }
dd30f9c8 929 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
eda17ab7 930 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
3189511a 931 )
703b6deb 932 fi
9c909460 933 else
30419e36
ER
934 if [ ! -d "$PACKAGE_DIR/.git" ]; then
935 if [ ! -d "$PACKAGE_DIR" ]; then
936 install -d $PACKAGE_DIR
3189511a
KK
937 fi
938 git init
a153a767 939 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git
dd30f9c8 940 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
48184c96 941 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
6a9f8358 942 CVSTAG=${CVSTAG:-"master"}
3189511a 943 fi
3f79cb18
KK
944 local refs=''
945 if [ -z "$ALL_BRANCHES" ]; then
946 refs="${CVSTAG}:remotes/${REMOTE_PLD}/${CVSTAG}"
947 fi
948 git fetch $DEPTH $REMOTE_PLD $refs || {
3189511a
KK
949 echo >&2 "Error: branch $CVSTAG does not exist"
950 exit 3
951 }
703b6deb 952 fi
f343238b 953 git fetch $REMOTE_PLD 'refs/notes/*:refs/notes/*'
0c3beb90 954
0d494abd 955 cvsignore_df .gitignore
703b6deb 956
588cb3a9 957 # add default log format to .gitignore if it is relative to package dir
703b6deb
ER
958 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
959 # substitute known "macros" to glob
52aad137 960 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\|TARGET\),*,g')
703b6deb
ER
961 if [ "$logfile" ]; then
962 cvsignore_df "$logfile"
daeab113 963 fi
9c909460 964 fi
703b6deb
ER
965
966 # create symlinks for tools
30419e36 967 if [ "$SYMLINK_TOOLS" != "no" -a -d "$PACKAGE_DIR" ]; then
2a8bedf9 968 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
046b715f 969 # skip tools that don't exist in top dir
703b6deb 970 [ -f $a ] || continue
046b715f 971 # skip tools that already exist
30419e36
ER
972 [ -f $PACKAGE_DIR/$a ] && continue
973 ln -s ../$a $PACKAGE_DIR
703b6deb
ER
974 cvsignore_df $a
975 done
976 fi
cd445739 977 fi
049ab214 978
b0121b45 979 if [ -n "$CVSTAG" ]; then
6217f407
KK
980 if git rev-parse --verify -q "$CVSTAG"; then
981 git checkout "$CVSTAG" --
982 elif git rev-parse --verify -q "refs/remotes/${REMOTE_PLD}/$CVSTAG"; then
983 git checkout -t "refs/remotes/${REMOTE_PLD}/$CVSTAG" > /dev/null
984 fi
985 if [ $(git rev-parse "$CVSTAG") != $(git rev-parse HEAD) ]; then
986 Exit_error "err_no_checkut" "$CVSTAG"
987 fi
ef4c7d3d 988 git merge --ff-only '@{u}'
2226518e 989 git symbolic-ref -q HEAD > /dev/null && [ "$NOCVSSPEC" != "yes" ] &&
52020f4c 990 if [ -n "$CVSDATE" ]; then
c4c0f339
KK
991 git checkout $(git rev-list -n1 --before="'$CVSDATE'" $CVSTAG) || exit 1
992 fi
b0121b45
KK
993 fi
994
30419e36 995 if [ ! -f "$PACKAGE_DIR/$SPECFILE" ]; then
518ff1fb 996 Exit_error err_no_spec_in_repo
cd445739
AM
997 fi
998
999 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
30419e36 1000 chmod $CHMOD_MODE $PACKAGE_DIR/$SPECFILE
cd445739
AM
1001 fi
1002 unset OPTIONS
30419e36 1003 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $PACKAGE_DIR/$SPECFILE
7e40520f 1004
ce40491a 1005 set_spec_target
cd445739
AM
1006}
1007
f6711e2a 1008find_mirror() {
9c909460 1009 cd "$REPO_DIR"
782518da 1010 local url="$1"
3526abd9 1011 if [ ! -f "mirrors" ] ; then
b11920fb 1012 ln -s ../rpm-build-tools/mirrors .
cd445739
AM
1013 fi
1014
1015 IFS="|"
782518da
ER
1016 local origin mirror name rest ol prefix
1017 while read origin mirror name rest; do
1018 # skip comments and empty lines
2faa4c32 1019 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
782518da
ER
1020 continue
1021 fi
a8c9a155
ER
1022 ol=$(echo -n "$origin" | wc -c)
1023 prefix=$(echo -n "$url" | head -c $ol)
cd445739 1024 if [ "$prefix" = "$origin" ] ; then
a8c9a155 1025 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
1026 echo -n "$mirror$suffix"
1027 return 0
1028 fi
1029 done < mirrors
1030 echo "$url"
1031}
1032
e7e0d4ec 1033# Warning: unpredictable results if same URL used twice
f6711e2a 1034src_no() {
8510980a
AM
1035 local file="$1"
1036 # escape some regexp characters if part of file name
298e75e2 1037 file=$(echo "$file" | sed -e 's#\([\+\*\.\&\#\?]\)#\\\1#g')
9c909460 1038 cd $PACKAGE_DIR
cd445739 1039 rpm_dump | \
8510980a 1040 grep -E "(SOURCE|PATCH)URL[0-9]*[ ]*${file}""[ ]*$" | \
647e3d7f
KK
1041 sed -e 's/.*\(SOURCE\|PATCH\)URL\([0-9][0-9]*\).*/\1\2/' | \
1042 head -n 1 | tr OURCEATH ourceath | xargs
1471f6d6 1043}
1044
f6711e2a 1045src_md5() {
e7e0d4ec 1046 [ "$NO5" = "yes" ] && return
cd445739
AM
1047 no=$(src_no "$1")
1048 [ -z "$no" ] && return
9c909460 1049 cd $PACKAGE_DIR
e7e0d4ec
ER
1050 local md5
1051
edcaeac2
ER
1052 # use "sources" file from package dir, like vim
1053 if [ -f sources ]; then
1054 md5=$(grep -s -v '^#' sources | \
9413a514 1055 grep -E "[ ]$(basename "$1")([ ,]|\$)" | \
e7e0d4ec
ER
1056 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
1057 grep -E '^[0-9a-f]{32}$')
1058
1059 if [ "$md5" ]; then
1060 if [ $(echo "$md5" | wc -l) != 1 ] ; then
edcaeac2 1061 echo "$SPECFILE: more then one entry in sources for $1" 1>&2
e7e0d4ec
ER
1062 fi
1063 echo "$md5" | tail -n 1
1064 return
1065 fi
cd445739 1066 fi
e7e0d4ec 1067
32131a0e 1068 source_md5=$(grep -iE "^#[ ]*(No)?$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://')
e7e0d4ec
ER
1069 if [ -n "$source_md5" ]; then
1070 echo $source_md5
cd445739 1071 else
7805dcb4
PZ
1072 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
1073 if [ -n "$source_md5" ]; then
1074 echo $source_md5
1075 else
1076 # we have empty SourceX-md5, but it is still possible
1077 # that we have NoSourceX-md5 AND NoSource: X
647e3d7f 1078 nosource_md5=`grep -i "^#[ ]*No$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
7805dcb4
PZ
1079 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
1080 echo $nosource_md5
1081 fi
cd445739 1082 fi
cd445739
AM
1083 fi
1084}
1085
f6711e2a 1086distfiles_path() {
06541433
JR
1087 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
1088}
1089
f6711e2a 1090distfiles_url() {
06541433 1091 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
1092}
1093
f6711e2a 1094distfiles_attic_url() {
06541433 1095 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
1096}
1097
f6711e2a 1098good_md5() {
cd445739
AM
1099 md5=$(src_md5 "$1")
1100 [ "$md5" = "" ] || \
1101 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
1102}
1103
f6711e2a 1104good_size() {
a8c9a155 1105 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 1106 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
1107}
1108
f6711e2a 1109cvsignore_df() {
947025e5 1110 if [ "$CVSIGNORE_DF" != "yes" ]; then
1111 return
1112 fi
0d494abd 1113 cvsignore=${PACKAGE_DIR}/.gitignore
7dc8d095
ER
1114
1115 # add only if not yet there
aa189b05 1116 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
947025e5 1117 echo "$1" >> $cvsignore
1118 fi
1119}
1120
71f8e908 1121# returns true if "$1" is ftp, http or https protocol url
f6711e2a 1122is_url() {
71f8e908
ER
1123 case "$1" in
1124 ftp://*|http://*|https://*)
1125 return 0
1126 ;;
1127 esac
1128 return 1
1129}
1130
f6711e2a 1131update_md5() {
ecba6ad5
ER
1132 if [ $# -eq 0 ]; then
1133 return
1134 fi
1135
1136 update_shell_title "update md5"
1137 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1138 set -x
1139 set -v
ecba6ad5
ER
1140 fi
1141
9c909460 1142 cd "$PACKAGE_DIR"
ecba6ad5
ER
1143
1144 # pass 1: check files to be fetched
1145 local todo
1146 local need_files
1147 for i in "$@"; do
1148 local fp=$(nourl "$i")
1149 local srcno=$(src_no "$i")
6392b5fd
ER
1150 if [ -n "$ADD5" ]; then
1151 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
647e3d7f 1152 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
9c909460 1153 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 1154 else
647e3d7f 1155 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
1156 fi
1157 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1158 need_files="$need_files $i"
1159 fi
1160 done
1161
1162 # pass 1a: get needed files
1163 if [ "$need_files" ]; then
1164 get_files $need_files
1165 fi
1166
1167 # pass 2: proceed with md5 adding or updating
1168 for i in "$@"; do
1169 local fp=$(nourl "$i")
1170 local srcno=$(src_no "$i")
647e3d7f 1171 local md5=$(grep -iE '^#[ ]*(No)?'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 1172 if [ -z "$md5" ]; then
9c909460 1173 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 1174 fi
71f8e908 1175 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
647e3d7f 1176 local tag="# $srcno-md5:\t"
71f8e908 1177 if [[ "$md5" == *NoSource* ]]; then
6663e1f3 1178 tag="# No$srcno-md5:\t"
6c1b2e7d
PZ
1179 elif [ -n "$USEDIGEST" ]; then
1180 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 1181 fi
ecba6ad5 1182 md5=$(md5sum "$fp" | cut -f1 -d' ')
647e3d7f 1183 echo "Updating $srcno ($md5: $fp)."
ecba6ad5 1184 perl -i -ne '
647e3d7f
KK
1185 print unless (/^\s*#\s*(No)?'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1186 print "'"$tag$md5"'\n" if /^'$srcno'\s*:\s+/i;
ecba6ad5 1187 ' \
9c909460 1188 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
1189 fi
1190 done
1191}
1192
f6711e2a 1193check_md5() {
60499e54 1194 local bad
3fbff8b8
ER
1195 [ "$NO5" = "yes" ] && return
1196
ecba6ad5
ER
1197 update_shell_title "check md5"
1198
1199 for i in "$@"; do
60499e54
AM
1200 bad=0
1201 if ! good_md5 "$i"; then
1202 echo -n "MD5 sum mismatch."
1203 bad=1
1204 fi
1205 if ! good_size "$i"; then
1206 echo -n "0 sized file."
1207 bad=1
ecba6ad5
ER
1208 fi
1209
60499e54
AM
1210 if [ $bad -eq 1 ]; then
1211 echo " Use -U to refetch sources,"
1212 echo "or -5 to update md5 sums, if you're sure files are correct."
1213 Exit_error err_no_source_in_repo $i
1214 fi
ecba6ad5
ER
1215 done
1216}
1217
f6711e2a 1218get_files() {
7cb24972 1219 update_shell_title "get_files"
cd445739
AM
1220
1221 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1222 set -x
1223 set -v
cd445739
AM
1224 fi
1225
f09c0772 1226 if [ $# -gt 0 ]; then
9c909460 1227 cd "$PACKAGE_DIR"
cd445739 1228
f2e42a41 1229 local nc=0
e7fa3b9f 1230 local get_files_cvs=""
3815b69a 1231 for i in "$@"; do
f2e42a41 1232 nc=$((nc + 1))
dcebdffb 1233 local cvsup=0
3815b69a 1234 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 1235 update_shell_title "$i"
f09c0772 1236 local fp=`nourl "$i"`
ecba6ad5 1237 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 1238 continue
18e5347d 1239 fi
ecba6ad5 1240
cd445739 1241 FROM_DISTFILES=0
e7e0d4ec 1242 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1243
1244 # we know if source/patch is present in cvs/distfiles
1245 # - has md5 (in distfiles)
1246 # - in cvs... ideas?
1247
1248 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1249 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1250 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1251 echo "Warning: no URL given for $i"
1252 fi
08908161 1253 target="$fp"
cd445739 1254
e7e0d4ec 1255 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1256 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1257 echo "$fp having proper md5sum already exists"
cd445739
AM
1258 continue
1259 fi
28b34560 1260
bc10f694 1261 # optionally prefer mirror over distfiles if there's mirror
28b34560 1262 # TODO: build url list and then try each url from the list
bc10f694 1263 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1264 url="$im"
1265 else
1266 url=$(distfiles_url "$i")
1267 fi
1268
cd445739
AM
1269 url_attic=$(distfiles_attic_url "$i")
1270 FROM_DISTFILES=1
ecba6ad5
ER
1271 # is $url local file?
1272 if [[ "$url" = [./]* ]]; then
18a52930 1273 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1274 ${GETLOCAL} $url $target
1275 else
9e9f8920
ER
1276 local uri=${url}
1277 # make shorter message for distfiles urls
1278 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1279 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1280 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1281 uri="df: $uri"
1282 fi
1283 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1284 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1285 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1286 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1287 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1288 fi
1289 fi
ecba6ad5
ER
1290
1291 # is it empty file?
1292 if [ ! -s "$target" ]; then
cd445739
AM
1293 rm -f "$target"
1294 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1295 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1296 ${GETLOCAL} $url_attic $target
1297 else
18a52930 1298 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1299 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1300 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1301 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1302 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739 1303 fi
1cd7fc57 1304 test -s "$target" || rm -f "$target"
cd445739
AM
1305 fi
1306 fi
ecba6ad5
ER
1307
1308 if [ -s "$target" ]; then
947025e5 1309 cvsignore_df $target
1310 else
cd445739
AM
1311 rm -f "$target"
1312 FROM_DISTFILES=0
1313 fi
cd445739
AM
1314 fi
1315
f09c0772 1316 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1317 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1318 im=$(find_mirror "$i")
cd445739
AM
1319 else
1320 im="$i"
1321 fi
ce40491a 1322 update_shell_title "${GETURI%% *}: $im"
99b8f51f 1323 ${GETURI} ${OUTFILEOPT} "$target" "$im" || \
33da77c4 1324 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1325 update_shell_title "${GETURI2%% *}: $im"
99b8f51f 1326 ${GETURI2} ${OUTFILEOPT} "$target" "$im"
7e365483 1327 fi
1cd7fc57 1328 test -s "$target" || rm -f "$target"
cd445739
AM
1329 fi
1330
dcebdffb
ER
1331 if [ "$cvsup" = 1 ]; then
1332 continue
1333 fi
1334
cd445739 1335 fi
ecba6ad5
ER
1336
1337 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1338 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
b3b584c5 1339 Exit_error err_no_source_in_repo $i
cd445739 1340 fi
2a5f078d 1341
ecba6ad5 1342 # we check md5 here just only to refetch immediately
a4b50627 1343 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1344 :
1345 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1346 # wrong md5 from distfiles: remove the file and try again
cd445739 1347 # but only once ...
deccc50e 1348 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1349 FROM_DISTFILES=2
1350 rm -f $target
18a52930 1351 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1352 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1353 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1354 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1355 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1356 fi
ecba6ad5 1357 if [ ! -s "$target" ]; then
cd445739 1358 rm -f "$target"
18a52930 1359 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1360 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1361 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1362 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1363 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1364 fi
1365 fi
1366 test -s "$target" || rm -f "$target"
1367 fi
cd445739 1368 done
e7fa3b9f
ER
1369 SHELL_TITLE_PREFIX=""
1370
cd445739
AM
1371
1372 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1373 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1374 if [ -n "$CHMOD_FILES" ]; then
1375 chmod $CHMOD_MODE $CHMOD_FILES
1376 fi
1377 fi
cd445739
AM
1378 fi
1379}
1380
7605fe95 1381tag_exist() {
8b6d1795
KK
1382# If tag exists and points to other commit exit with error
1383# If it existsts and points to HEAD return 1
1384# If it doesn't exist return 0
f8bfce7d 1385 local _tag="$1"
8b6d1795 1386 local sha1=$(git rev-parse HEAD)
7605fe95
KK
1387 echo "Searching for tag $_tag..."
1388 if [ -n "$DEPTH" ]; then
8b6d1795 1389 local ref=$(git ls-remote $REMOTE_PLD "refs/tags/$_tag" | cut -c -40)
7605fe95 1390 else
7baf7b2f 1391 local ref=$(git show-ref -s "refs/tags/$_tag")
7605fe95 1392 fi
8b6d1795
KK
1393 [ -z "$ref" ] && return 0
1394 [ "$ref" = "$sha1" ] || Exit_error err_tag_exists "$_tag"
1395 return 1
7605fe95
KK
1396}
1397
cd445739 1398make_tagver() {
ce40491a 1399 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1400 set -x
1401 set -v
ce40491a 1402 fi
78eab2a1 1403
ce40491a
ER
1404 # Check whether first character of PACKAGE_NAME is legal for tag name
1405 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1406 TAG_PREFIX=tag_
1407 fi
d712cc12
ER
1408
1409 # NOTE: CVS tags may must not contain the characters `$,.:;@'
8c043136 1410 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE)
d712cc12 1411
8c043136 1412 # Remove @kernel.version_release from TAGVER because tagging sources
ce40491a 1413 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1414 # besides, %{_kernel_ver_str} is not expanded.
1415
8c043136 1416 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1@%{_kernel_ver_str}
d712cc12
ER
1417 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1418
8c043136 1419 TAGVER=${TAGVER%@*}
ce40491a 1420 echo -n "$TAGVER"
cd445739
AM
1421}
1422
f6711e2a 1423tag_files() {
cd445739 1424 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1425 set -x
1426 set -v
cd445739
AM
1427 fi
1428
73ef63d8
ER
1429 echo "Version: $PACKAGE_VERSION"
1430 echo "Release: $PACKAGE_RELEASE"
cd445739 1431
c9100f10 1432 local _tag
73ef63d8 1433 if [ "$TAG_VERSION" = "yes" ]; then
c9100f10 1434 _tag=`make_tagver`
73ef63d8
ER
1435 fi
1436 if [ -n "$TAG" ]; then
c9100f10 1437 _tag="$TAG"
73ef63d8 1438 fi
c9100f10 1439 echo "tag: $_tag"
cd445739 1440
39dcc7de 1441 local OPTIONS="tag $CVS_FORCE"
cd445739 1442
9c909460 1443 cd "$PACKAGE_DIR"
03db3356 1444
ace99bc6
KK
1445 if tag_exist $_tag || [ -n "$CVS_FORCE" ]; then
1446 update_shell_title "tag sources: $_tag"
1447 git $OPTIONS $_tag || exit
1448 git push $CVS_FORCE $REMOTE_PLD tag $_tag || Exit_error err_remote_problem $REMOTE_PLD
1449 else
1450 echo "Tag $_tag already exists and points to the same commit"
1451 fi
cd445739
AM
1452}
1453
f6711e2a 1454branch_files() {
cd445739 1455 TAG=$1
f663f264 1456 echo "Git branch: $TAG"
518ff1fb 1457 shift
cd445739 1458
cd445739 1459 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1460 set -x
1461 set -v
cd445739
AM
1462 fi
1463
f663f264 1464 local OPTIONS="branch $CVS_FORCE"
c10fa4fa 1465
9c909460 1466 cd "$PACKAGE_DIR"
f663f264 1467 git $OPTIONS $TAG || exit
cd445739
AM
1468}
1469
1470
3009b80d
ER
1471# this function should exit early if package can't be built for this arch
1472# this avoids unneccessary BR filling.
1473check_buildarch() {
1474 local out ret
13c3c336 1475 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1476 ret=$?
1477 if [ $ret -ne 0 ]; then
1478 echo >&2 "$out"
1479 exit $ret
1480 fi
1481}
1482
9d99a240
ER
1483# from relup.sh
1484set_release() {
1485 local specfile="$1"
1486 local rel="$2"
1487 local newrel="$3"
1488 sed -i -e "
1489 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1490 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1491 " $specfile
1492}
1493
1494set_version() {
1495 local specfile="$1"
bc8502e6
ER
1496 local ver="$2" subver=$ver
1497 local newver="$3" newsubver=$newver
1498
1499 # try handling subver, everything that's not numeric-dotted in version
1500 if grep -Eq '%define\s+subver' $specfile; then
1501 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1502 ver=${ver%$subver}
1503 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1504 newver=${newver%$newsubver}
1505 fi
9d99a240
ER
1506 sed -i -e "
1507 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
bc8502e6 1508 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
9d99a240
ER
1509 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1510 " $specfile
1511}
1512
cacef28c 1513try_upgrade() {
cd445739 1514 if [ -n "$TRY_UPGRADE" ]; then
9d99a240 1515 local TNOTIFY TNEWVER TOLDVER
ce40491a 1516 update_shell_title "build_package: try_upgrade"
9d99a240 1517
cacef28c 1518 cd "$PACKAGE_DIR"
1519
0907f1eb
ER
1520 if [ "$UPGRADE_VERSION" ]; then
1521 TNEWVER=$UPGRADE_VERSION
cd445739 1522 else
0907f1eb
ER
1523 if [ -n "$FLOAT_VERSION" ]; then
1524 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1525 else
1526 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1527 fi
cd445739 1528
b9bef5ce
ER
1529 # pldnotify.awk does not set exit codes, but it has match for ERROR
1530 # in output which means so.
1531 if [[ "$TNOTIFY" = *ERROR* ]]; then
1532 echo >&2 "$TNOTIFY"
1533 exit 1
1534 fi
1535
0907f1eb
ER
1536 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1537 fi
cd445739
AM
1538
1539 if [ -n "$TNEWVER" ]; then
1540 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
9d99a240 1541 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
257af81b
ER
1542 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1543 cp -f $SPECFILE $SPECFILE.bak
1544 fi
cd445739 1545 chmod +w $SPECFILE
cacef28c 1546 set_release $SPECFILE $PACKAGE_RELEASE 1
9d99a240 1547 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
518ff1fb 1548 parse_spec
6decb793
ER
1549 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1550 echo >&2 "Upgrading version failed, you need to update spec yourself"
1551 exit 1
1552 fi
cacef28c 1553 return 1
cd445739
AM
1554 fi
1555 fi
cacef28c 1556 return 0
1557}
1558
1559build_package() {
1560 update_shell_title "build_package"
1561 if [ -n "$DEBUG" ]; then
1562 set -x
1563 set -v
1564 fi
1565
9c909460 1566 cd "$PACKAGE_DIR"
2a5f078d 1567
cd445739
AM
1568 case "$COMMAND" in
1569 build )
1570 BUILD_SWITCH="-ba" ;;
1571 build-binary )
1572 BUILD_SWITCH="-bb" ;;
1573 build-source )
1574 BUILD_SWITCH="-bs --nodeps" ;;
1575 build-prep )
1576 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1577 build-build )
1578 BUILD_SWITCH="-bc" ;;
1579 build-install )
1580 BUILD_SWITCH="-bi" ;;
1581 build-list )
1582 BUILD_SWITCH="-bl" ;;
1583
cd445739 1584 esac
c890b916 1585
2e5be021 1586 update_shell_title "build_package: $COMMAND"
12da9e3d 1587 local logfile retval
cd445739 1588 if [ -n "$LOGFILE" ]; then
12da9e3d
ER
1589 logfile=`eval echo $LOGFILE`
1590 if [ -d "$logfile" ]; then
1591 echo "Log file $logfile is a directory."
cd445739 1592 echo "Parse error in the spec?"
518ff1fb 1593 Exit_error err_build_fail
cd445739
AM
1594 fi
1595 if [ -n "$LASTLOG_FILE" ]; then
12da9e3d 1596 echo "LASTLOG=$logfile" > $LASTLOG_FILE
cd445739 1597 fi
12da9e3d
ER
1598 fi
1599
1600 local specdir=$(insert_gitlog $SPECFILE)
1601 # FIXME: eval here is exactly why?
1602 PATH=$CLEAN_PATH eval teeboth "'$logfile'" ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specdir/$SPECFILE
1603 retval=$?
1604 rm -r $specdir
1605
1606 if [ -n "$logfile" ] && [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1607 if [ "$retval" -eq "0" ]; then
1608 mv $logfile $LOGDIROK
1609 else
1610 mv $logfile $LOGDIRFAIL
cd445739 1611 fi
8ba5cdda 1612 fi
12da9e3d
ER
1613
1614 if [ "$retval" -ne "0" ]; then
cd445739 1615 if [ -n "$TRY_UPGRADE" ]; then
cacef28c 1616 echo "\nUpgrade package to new version failed."
257af81b 1617 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
cacef28c 1618 echo "Restoring old spec file."
257af81b
ER
1619 mv -f $SPECFILE.bak $SPECFILE
1620 fi
cacef28c 1621 echo ""
cd445739 1622 fi
518ff1fb 1623 Exit_error err_build_fail
cd445739
AM
1624 fi
1625 unset BUILD_SWITCH
1626}
1627
f6711e2a 1628nourl() {
cd445739
AM
1629 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1630}
1631
f6711e2a 1632install_required_packages() {
cd445739
AM
1633 run_poldek -vi $1
1634 return $?
1635}
1636
f6711e2a 1637find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1638 local SPEC="$1"
fa4bf1df
ER
1639 awk -F"\n" '
1640 /^%changelog/ { exit }
fa4bf1df
ER
1641 /^%bcond_with/{
1642 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1643 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1644 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1645 print bcond
1646 }' $SPEC | LC_ALL=C sort -u
1647}
1648
117d9861 1649process_bcondrc() {
301cbfd4
ER
1650 # expand bconds from ~/.bcondrc
1651 # The file structure is like gentoo's package.use:
1652 # ---
1653 # * -selinux
1654 # samba -mysql -pgsql
47a8df12 1655 # w32codec-installer license_agreement
301cbfd4
ER
1656 # php +mysqli
1657 # ---
15e34b63 1658 if [ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ]); then
117d9861
ER
1659 :
1660 else
1661 return
1662 fi
301cbfd4 1663
117d9861 1664 SN=${SPECFILE%%\.spec}
c8a3e2ac 1665
117d9861
ER
1666 local bcondrc=$HOME/.bcondrc
1667 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1668
117d9861 1669 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1670
117d9861
ER
1671 while read pkg flags; do
1672 # ignore comments
1673 [[ "$pkg" == \#* ]] && continue
1674
1675 # any package or current package?
1676 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1677 for flag in $flags; do
1678 local opt=${flag#[+-]}
1679
1680 # use only flags which are in this package.
1681 if [[ $bcond_avail = *${opt}* ]]; then
1682 if [[ $flag = -* ]]; then
1683 if [[ $BCOND != *--with?${opt}* ]]; then
1684 BCOND="$BCOND --without $opt"
1685 fi
1686 else
1687 if [[ $BCOND != *--without?${opt}* ]]; then
1688 BCOND="$BCOND --with $opt"
301cbfd4
ER
1689 fi
1690 fi
117d9861
ER
1691 fi
1692 done
1693 fi
1694 done < $bcondrc
1695 update_shell_title "parse ~/.bcondrc: DONE!"
1696}
1697
8ff97f39 1698set_bconds_values() {
117d9861
ER
1699 update_shell_title "set bcond values"
1700
1701 AVAIL_BCONDS_WITHOUT=""
1702 AVAIL_BCONDS_WITH=""
8ff97f39 1703
5a28189c 1704 if grep -Eq '^# *_with' ${SPECFILE}; then
8ff97f39
ER
1705 echo >&2 "ERROR: This spec has old style bconds."
1706 exit 1
1707 fi
1708
1709 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1710 return
301cbfd4
ER
1711 fi
1712
117d9861
ER
1713 local bcond_avail=$(find_spec_bcond $SPECFILE)
1714 process_bcondrc "$SPECFILE"
1715
fa4bf1df 1716 update_shell_title "parse bconds"
2a5f078d 1717
8ff97f39
ER
1718 local opt bcond
1719 for opt in $bcond_avail; do
1720 case "$opt" in
1721 without_*)
1722 bcond=${opt#without_}
10d92f71
ER
1723 case "$BCOND" in
1724 *--without?${bcond}*)
8ff97f39 1725 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
10d92f71
ER
1726 ;;
1727 *)
8ff97f39 1728 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
10d92f71
ER
1729 ;;
1730 esac
cd445739 1731 ;;
8ff97f39
ER
1732 with_*)
1733 bcond=${opt#with_}
10d92f71
ER
1734 case "$BCOND" in
1735 *--with?${bcond}*)
8ff97f39 1736 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
10d92f71
ER
1737 ;;
1738 *)
8ff97f39 1739 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
10d92f71
ER
1740 ;;
1741 esac
cd445739 1742 ;;
8ff97f39
ER
1743 *)
1744 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1745 exit 1
1746 ;;
1747 esac
1748 done
cd445739
AM
1749}
1750
f6711e2a 1751run_sub_builder() {
cd445739 1752 package_name="${1}"
af6b168f 1753 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1754 #
1755